//+------------------------------------------------------------------+
//|                                                    TickIndicator |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Denis Zyatkevich"
#property description "    ."
#property version   "1.00"
//     
#property indicator_separate_window
//   :   Bid  Ask
#property indicator_plots 2
//   
#property indicator_buffers 2
//   Bid    - 
#property indicator_type1 DRAW_LINE
//     Bid
#property indicator_color1 Red
//     Bid
#property indicator_style1 STYLE_SOLID
//      Bid
#property indicator_label1 "Bid"
//   Ask    - 
#property indicator_type2 DRAW_LINE
//     Ask
#property indicator_color2 Blue
//     Ask
#property indicator_style2 STYLE_SOLID
//      Ask
#property indicator_label2 "Ask"

//  BidLineEnable ,    Bid
input bool BidLineEnable=true; // Show Bid Line
//  AskLineEnable ,    Ask
input bool AskLineEnable=true; // Show Ask Line
//  path_prefix       
input string path_prefix=""; // FileName Prefix

//  tick_stored    
int ticks_stored;
//  BidBuffer[]  AskBuffer[] -    
double BidBuffer[],AskBuffer[];
//+------------------------------------------------------------------+
//|  OnInit()                                                 |
//+------------------------------------------------------------------+
void OnInit()
  {
//  BidBuffer[]   
   SetIndexBuffer(0,BidBuffer,INDICATOR_DATA);
//  AskBuffer[]   
   SetIndexBuffer(1,AskBuffer,INDICATOR_DATA);
//      Bid
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//      Ask
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
  }
//+------------------------------------------------------------------+
//|  OnCalculate()                                            |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   //  file_handle -  () ;
   // BidPosition  AskPosition -    Bid  Ask  ;
   // line_string_len -  ,   , i -  ;
   int file_handle,BidPosition,AskPosition,line_string_len,i;
   //  last_price_bid -    Bid
   double last_price_bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   //  last_price_ask -    Ask
   double last_price_ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   //  filename -  , file_buffer -  
   //        
   string filename,file_buffer;
   //      path_prefix, 
   //     ".txt"
   StringConcatenate(filename,path_prefix,Symbol(),".txt");
   //      ,  ANSI,    
   file_handle=FileOpen(filename,FILE_READ|FILE_WRITE|FILE_ANSI|FILE_SHARE_READ);
   //      OnCalculate,    
   if(prev_calculated==0)
     {
      //         
      line_string_len=StringLen(FileReadString(file_handle))+2;
      //    (  ,   rates_total/2)
      if(FileSize(file_handle)>(ulong)line_string_len*rates_total/2)
        {
         //       rates_total/2 
         FileSeek(file_handle,-line_string_len*rates_total/2,SEEK_END);
         //       
         FileReadString(file_handle);
        }
      //   
      else
        {
         //      
         FileSeek(file_handle,0,SEEK_SET);
        }
      //    
      ticks_stored=0;
      //    
      while(FileIsEnding(file_handle)==false)
        {
         //    
         file_buffer=FileReadString(file_handle);
         //   ,     6- 
         if(StringLen(file_buffer)>6)
           {
            //    Bid  
            BidPosition=StringFind(file_buffer," ",StringFind(file_buffer," ")+1)+1;
            //    Ask  
            AskPosition=StringFind(file_buffer," ",BidPosition)+1;
            //   Bid ,   Bid   BidBuffer[]
            if(BidLineEnable) BidBuffer[ticks_stored]=StringToDouble(StringSubstr(file_buffer,BidPosition,AskPosition-BidPosition-1));
            //   Ask ,   Ask   AskBuffer[]
            if(AskLineEnable) AskBuffer[ticks_stored]=StringToDouble(StringSubstr(file_buffer,AskPosition));
            //    
            ticks_stored++;
           }
        }
     }
   //       
   else
     {
      //      
      FileSeek(file_handle,0,SEEK_END);
      //  ,     
      StringConcatenate(file_buffer,TimeCurrent()," ",DoubleToString(last_price_bid,_Digits)," ",DoubleToString(last_price_ask,_Digits));
      //    
      FileWrite(file_handle,file_buffer);
      //   Bid ,    BidBuffer[]   Bid
      if(BidLineEnable) BidBuffer[ticks_stored]=last_price_bid;
      //   Ask ,    AskBuffer[]   Ask
      if(AskLineEnable) AskBuffer[ticks_stored]=last_price_ask;
      //    
      ticks_stored++;
     }
   //  
   FileClose(file_handle);
   //          
   if(ticks_stored>=rates_total)
     {
      //   tick_stored/2    
      for(i=ticks_stored/2;i<ticks_stored;i++)
        {
         //   Bid ,     BidBuffer[]  tick_stored/2 
         if(BidLineEnable) BidBuffer[i-ticks_stored/2]=BidBuffer[i];
         //   Ask ,     AskBuffer[]  tick_stored/2 
         if(AskLineEnable) AskBuffer[i-ticks_stored/2]=AskBuffer[i];
        }
      //   
      ticks_stored-=ticks_stored/2;
     }
   //   Bid     
   PlotIndexSetInteger(0,PLOT_SHIFT,rates_total-ticks_stored);
   //   Ask     
   PlotIndexSetInteger(1,PLOT_SHIFT,rates_total-ticks_stored);
   //   Bid ,      BidBuffer[]
   //   Bid      
   if(BidLineEnable) BidBuffer[rates_total-1]=last_price_bid;
   //   Ask ,      AskBuffer[]
   //   Ask      
   if(AskLineEnable) AskBuffer[rates_total-1]=last_price_ask;
   //    OnCalculate(),  ,   
   return(rates_total);
  }
//+------------------------------------------------------------------+
